#!/usr/bin/perl

#=====================================================================
# 作成
#=====================================================================
#   名    称: BBS Type3 Ver100
#   作成者: CANDY CGI
#   作成者サイト: http://www.candy-cgi.com/

#=====================================================================
# 画像のサイズ(幅と高さ)を取得するサブルーチン GetImageSize について
#=====================================================================
#  このサブルーチンの著作権はcachu様にあります
#  
#  http://cachu.xrea.jp/index.html <cachu@cocoa.ocn.ne.jp>
#  Copyright (C) cachu

#=====================================================================
#　設定の変更【ここから】
#=====================================================================
#■このファイルの先頭の１行のperlのパスを指定してください。（「#!/usr/local/bin/perl」や『#!/usr/bin/perl』など）
#「#!」の前には、空文字や空行や他の文字が入らないようにしてください。

#■更新パス
#  設定の変更などをした時に『index.cgi?更新パス』にアクセスすると掲示板が更新されます。
#  設定の変更をした時に更新しなかった場合は、新しい投稿があった時に更新されます。
$n_pass = '12345';

#■掲示板の名前
$site_title = 'Post From Shockwave';

#■トップページの[HOME]のリンク先　[HOME]を表示しない場合は''
$home = '';

#◇======投稿設定========◇
#■名前の記入を必須にする場合は'1'　しない場合は''
$n_che = '';

#■タイトルの記入を必須にする場合は'1'　しない場合は''
$t_che = '';

#■メッセージの記入を必須にする場合は'1'　しない場合は''
$m_che = '';

#■名前欄が未記入だった場合の名前　指定しない場合は''
$no_name = '名無しさん';

#■タイトルが未記入だった場合の名前　指定しない場合は''
$no_title = 'No Title';

#■名前の最大文字数（『150』と指定した場合の最大数は半角英数字で150文字、日本語で約75文字になります）
$name_max = '36';

#■タイトルの最大文字数（『150』と指定した場合の最大数は半角英数字で150文字、日本語で約75文字になります）
$title_max = '40';

#■メッセージの最大文字数（『150』と指定した場合の最大数は半角英数字で150文字、日本語で約75文字になります）
$message_max = '1000';

#■メッセージの改行の最大回数　指定しない場合は''
$br_max = '20';

#■メッセージ内の『http』の最大数　指定しない場合は''
#  URLが大量に書き込まれるのを防ぐ設定です
$http_max = '3';

#■連続投稿を禁止する秒数　指定しない場合は''
$post_time = '30';

#◇======表示設定========◇
#■1ページに表示する投稿数　指定しない場合は''
$page_max = '15';

#■掲示板全体で表示する投稿数　すべて表示する場合は''
$log_limit = '30';

#■新しい投稿が最上部の場合は'1'　最下部の場合は'2'
$toukou = '1';

#■メッセージにURLがあったら自動的にリンクする場合は'1'　しない場合は''
$m_link = '';

#◇======保存、削除の設定========◇
#■投稿と画像の保存、削除設定
#  投稿と画像を削除しないですべて保存する場合は'0'
#  掲示板全体で表示する投稿数を超えると古い順に削除の場合は'1'
#  一定期間後に削除する場合は'2'
$log_delet = '2';

#■投稿と画像を保存する日数（上記で'2'の一定期間後に削除を選択した場合のみ有効）
#  10日間投稿と画像を保存する場合は'10'
$log_time = '10';

#◇======投稿拒否、禁止の設定========◇
#■プロキシ経由での投稿を禁止する場合は'1' しない場合は''
#  簡易的なプロキシチェックです
$proxy = '';

#■IPからホスト名に変換できない場合は投稿拒否する場合は'1'　しない場合は''
#  国内の主要なIPは変換できますが、外国の怪しげなIPなどは変換できないことが多く、
#  それを拒否することでスパムを減らす設定です
$sec_check = '';

#■投稿許可IP  ""で囲って記入　複数設定する場合は『,』で区切ってください　例 ("0.0.0.0","1.1.1.1","2.2.2.2")など
#  上記の２つの設定でプロキシ経由の場合と、ホスト名に変換できないIPを投稿禁止にしますが、
#  プロキシ経由の場合や、変換できないIPでも投稿を許可したい場合はそのIPを記述してください
#  必要ない場合は()
@ok_ip = ();

#■投稿許可ホスト  ""で囲って記入　複数設定する場合は『,』で区切ってください　例 ("softbank","jp")など
#  プロキシ経由の場合でも投稿を許可したいホストがある場合はそのホストを記述してください
#　設定した文字列がホストに含まれる場合は投稿が許可されます。
#  必要ない場合は()
@ok_host = ();

#■メッセージに半角英数字や特定の記号しかない場合は投稿拒否する場合は'1' しない場合は''
#  外国からのスパムを減らすための設定です
$mes_check = '';

#■投稿禁止ワード  ""で囲って記入　複数設定する場合は『,』で区切ってください　例 ("アダルト","エロ")など
#　設定した文字列が名前かタイトル、メッセージに含まれる場合、投稿できません
#  必要ない場合は()
@deny_words = ("アダルト","エロ");

#■投稿禁止IP  ""で囲って記入  複数設定する場合は『,』で区切ってください　例 ("0.0.0.0","255.255.255.255","127.0.0.1")など
#  必要ない場合は()
@deny_ip = ();

#■投稿禁止ホスト  ""で囲って記入  複数設定する場合は『,』で区切ってください　例 ("proxy","cache","via")など
#　設定した文字列がリモートホストに含まれる場合、投稿できません
#  必要ない場合は()
@deny_host = ();

#◇======管理人設定========◇
#■書き込み時に名前欄にパスワードを入れると管理人や関係者のみが使える言葉が表示されます
#  数に制限はないので必要な分だけ増やすことができます
#  $ori_key[数字]の数字を順番に増やして、("")の中に、キーワードやパスワードを<>で区切って書き込んでください
#  (左)　管理人のみが使える言葉
#  (中)　管理人のみが使える言葉を利用者が入力した場合に変換する言葉
#  (右)　管理人のみが使える言葉を表示するパスワード（半角英数字のみ）
$ori_key[0] = ("管理人<>偽管理人<>aglpb");
$ori_key[1] = ("支配人<>偽支配人<>lgbjp");
$ori_key[2] = ("関係者<>偽関係者<>hnhyh");

#◇======コメント設定========◇
#■上部コメント（トップページ）
$header_comment_top = '';

#■上部コメント（２ページ目以降）
$header_comment = '';

#■下部コメント（トップページ）
$footer_comment_top = '';

#■下部コメント（２ページ目以降）
$footer_comment = '';

#◇======画像設定========◇
#■投稿画像の最大サイズ（キロバイト指定）
$max = '500';

#■縮小表示の時の画像の最大幅（ピクセル指定）
$wid_max = '200';

#■縮小表示の時の画像の最大高（ピクセル指定）
$hei_max = '150';


#=====================================================================
#　設定の変更【ここまで】
#=====================================================================

use CGI;
use Jcode;
#--awa-->
use MIME::Base64;
#--awa--<
$back = './';
$log = 'log.cgi';
$file = "file";

$time = time;

$ip = $ENV{'REMOTE_ADDR'};
$host = gethostbyaddr(pack('C4',split(/\./,$ip)),2) || $ip;

$query = new CGI;

$name = $query->param('jdvos');
$title = $query->param('ghjfk');
$message = $query->param('kvkfp');

#--awa-->
$base64 = $query->param('base64');
if ($base64 == 1){
  $name =  decode_base64( $name ) ;
  $message = decode_base64(  $message ) ;
}
#--awa--<

$env = $ENV{'QUERY_STRING'};

if ($env eq "") {&check;}
elsif ($env eq $n_pass){&make;}
else {&error("エラーが発生しました");}


sub check {
my $ip_xxx = "yes";

if($sec_check eq "1" && $ip eq $host){
my $ok_x = @ok_ip;
if($ok_x eq "0"){$ip_xxx = "no";}

foreach $ok (@ok_ip) {
if ($ip eq $ok){$ip_xxx = "yes"; last;}
else{$ip_xxx = "no";}
}
}

if($ip_xxx eq "no"){&error("ホスト名が取得できませんでした");}

my $p_env = "0";

if($proxy eq "1"){
if($ENV{'HTTP_VIA'}||$ENV{'HTTP_FORWARDED'}||$ENV{'HTTP_X_FORWARDED_FOR'}){$p_env = "1";}
if($ENV{'HTTP_USER_AGENT'} =~ /via|cache|delegate/i){$p_env = "1";}
}

if($proxy eq "1" && $p_env eq "1"){
foreach $ok_h (@ok_host) {
if ($host =~ /$ok_h/i){$p_env = "0"; last;}
else{$p_env = "1";}
}

if($p_env eq "1"){
foreach $ok_i (@ok_ip) {
if ($ip eq $ok_i){$p_env = "0"; last;}
else{$p_env = "1";}
}
}

}

if($p_env eq "1"){&error("プロキシ経由の投稿はできません");}

foreach $d_ip (@deny_ip) {if ($ip eq $d_ip) {&error("投稿できないIPです");}}
foreach $d_host (@deny_host) {if ($host =~ /$d_host/i) {&error("投稿できないホストです");}}

($sec,$min,$hour,$mday,$mon,$year,$wno) = localtime(time);
@wdays = ('日','月','火','水','木','金','土');
$year = substr($year,2,2);
$niti = sprintf("%02d/%02d/%02d(%s) %02d:%02d:%02d",$year,$mon+1,$mday,$wdays[$wno],$hour,$min,$sec);

open(IN, "$log"); 
@log = <IN>; 
close(IN); 

if($post_time ne ""){
foreach $data (@log) {
my ($nox,$timex,$ipx,$namex,$titlex,$nitix,$messagex,$up_filex,$widthx,$heightx) = split(/<>/, $data);
my $now = $time - $timex;
if($now <= $post_time && $ip eq $ipx) {&error("連続投稿はできません");}
}
}

if($n_che eq "1" && $name eq ""){&error("名前が未記入です");}
if($t_che eq "1" && $title eq ""){&error("タイトルが未記入です");}
if($m_che eq "1" && $message eq ""){&error("メッセージが未記入です");}

$name =~ s/"/&quot;/g;
$name =~ s/</&lt;/g;
$name =~ s/>/&gt;/g;
$name =~ s/\r\n//g;
$name =~ s/\n//g;
$name =~ s/\r//g;

#--awa-->
#&Jcode::convert(*name, "sjis");
#--awa--<
   $name =~ s/◆/◇/g;

if ($name =~ /#/) {
my $bes = $`;
my $tripkey = $';
   $tripkey =~ s/&r//g;
   $tripkey =~ s/＃/#/g;
   $tripkey =~ s/●/○/g;
   $tripkey =~ s/★/☆/g;
   $tripkey =~ s/管理/”管理”/g;
   $tripkey =~ s/削除/”削除”/g;
   $tripkey =~ s/復帰/”復帰”/g;
   $tripkey =~ s/山崎渉/fusianasan/g;

my $salt = substr($tripkey.'H.',1,2);
   $salt =~ s/[^\.-z]/\./go;
   $salt =~ tr/:;<=>?@[\\]^_`/ABCDEFGabcdef/;
my $trip = crypt($tripkey,$salt);
   $trip = substr($trip,-10);
   $trip = '◆'.$trip;

   $name = "$bes$trip";
}

if($ori_key[0] ne "") {

foreach $ooo (@ori_key) {
my ($ori_words1,$ori_words2,$ori_pass) = split(/<>/, $ooo);
if($name =~ /$ori_words1/){$name =~ s/$ori_words1/$ori_words2/g;}
}

foreach $ooo (@ori_key) {
my ($ori_words1,$ori_words2,$ori_pass) = split(/<>/, $ooo);
if($name =~ /$ori_pass/){$name =~ s/$ori_pass/$ori_words1/g;}
}

}

if($name eq "") {$name = $no_name;}

$title =~ s/&/&amp;/g;
$title =~ s/"/&quot;/g;
$title =~ s/</&lt;/g;
$title =~ s/>/&gt;/g;
$title =~ s/\r\n//g;
$title =~ s/\n//g;
$title =~ s/\r//g;

#--awa-->
#&Jcode::convert(*title, "sjis");
#--awa--<

if($title eq "") {$title = $no_title;}

$message =~ s/&/&amp;/g;
$message =~ s/"/&quot;/g;
$message =~ s/</&lt;/g;
$message =~ s/>/&gt;/g;
$message =~ s/\r\n/<br>/g;
$message =~ s/\n/<br>/g;
$message =~ s/\r/<br>/g;

#--awa-->
#&Jcode::convert(*message, "sjis");
#--awa--<

my $br_count = 0;
while($message =~ /<br>/ig){$br_count++;}

if($br_max ne "" && $br_max < $br_count) {&error("改行が多すぎます");}

while($message =~ /http/ig){$http_count++;}

if($http_max ne "" && $http_max < $http_count) {&error("URLが多すぎます");}


if(length($name) >= $name_max) {&error("名前が長すぎます");}
if(length($title) >= $title_max) {&error("タイトルが長すぎます");}
if(length($message) >= $message_max) {&error("メッセージが長すぎます");}

foreach $d_words (@deny_words) {if ($name =~ /$d_words/i) {&error("名前に投稿できない言葉が含まれています");} }
foreach $d_words (@deny_words) {if ($title =~ /$d_words/i) {&error("タイトルに投稿できない言葉が含まれています");} }
foreach $d_words (@deny_words) {if ($message =~ /$d_words/i) {&error("メッセージに投稿できない言葉が含まれています");} }

if($mes_check eq "1" && $message !~ /[^\w\-.,:;\~\^\/?\@&=+\$%#! 　<>]/) {&error("メッセージに英数字や記号しかありません");}

if($m_link eq "1") {$message =~ s/(https?:\/\/[\w\-.,:;\~\^\/?\@&=+\$%#!]+)/<a href=\"$1\">$1<\/a>/g;}

($no) = split(/<>/, $log[0]); 
$no++;

if($ip eq $host) {$host = "none";}

if($query->param('up')) {&upfile;}

unshift @log, "$no<>$time<>$ip<>$host<>$name<>$title<>$niti<>$message<>$up_file<>$width<>$height\n";

&page;

opendir(DIR , '.');
while($list = readdir(DIR)){if ($list =~ /CGItemp/i) {unlink ($list);}}

&end("投稿が完了しました");
}


sub page {
my $de_log = @log;

$log_time = $log_time * 86400;

if($log_delet eq "1") {

for ($xox=$log_limit; $xox<$de_log; $xox++) {
($nof,$timef,$ipf,$hostf,$namef,$titlef,$nitif,$messagef,$up_filef,$widthf,$heightf) = split(/<>/, $log[$xox]);
unlink ($up_filef);
}

splice @log,$log_limit;}

if($log_delet eq "2") {
for ($z=0; $z<$de_log; $z++) {($noz,$timez,$ipz,$hostz,$namez,$titlez,$nitiz,$messagez,$up_filez,$widthz,$heightz) = split(/<>/, $log[$z]);

$timez = $timez + $log_time;

if($timez <= $time) {

my $def = $de_log - $z;
   $def = $def + $z;

for ($xox=$z; $xox<$def; $xox++) {
($nof,$timef,$ipf,$hostf,$namef,$titlef,$nitif,$messagef,$up_filef,$widthf,$heightf) = split(/<>/, $log[$xox]);

unlink ($up_filef);
}

splice @log,$z;
last;}
}
}

my @log_in = @log;

if($log_limit ne "") {splice @log,$log_limit;}

my $start = 0;
my $count = 1;

if($page_max eq ''){$page_max = @log;}

if(@log > 0){
my $zan = @log;
my $limit = 0;
my $all = int((@log - 1) / $page_max);
if($all < 0){$all = 0;}
$all = $all + 1;

while ($limit < @log){
if($zan > $page_max){
$end = $start + $page_max;
&html($count,$start,$end,$all);
$start = $start + $page_max;
$zan = @log - $start;
$count = $count + 1;
$limit = $limit + $page_max;}
else
{
if($zan > 0){
$end = $start + $zan;
&html($count,$start,$end,$all);}

$count = $count + 1;

&del($count);

$limit = @log;}}
}

else{
my $end = 1;
my $all = 1;

&html($count,$start,$end,$all);
&del($count);}

open(OUT,"+< $log");
eval{ flock(OUT, 2);};
eval{ truncate(OUT, 0);};
seek(OUT, 0, 0);
print OUT @log_in;
eval{ flock(OUT, 8);};
close(OUT);
}


sub make{
open(IN, "$log"); 
@log = <IN>; 
close(IN); 

&page;

opendir(DIR , '.');
while($list = readdir(DIR)){if ($list =~ /CGItemp/i) {unlink ($list);}}

&end("更新が完了しました");
}


sub del {
my $ppp = $_[0];

if($ppp eq "1"){$ppp = 2;}

my $xxx = "$ppp.html";
my $yyy = 0;

while ($yyy < 2)
{
if(unlink ($xxx)){
$ppp = $ppp + 1;
$xxx = "$ppp.html";
$yyy = 1;}
else{$yyy = 2;}
}
}


sub upfile{
@data = ("image/jpeg","image/pjpeg","image/gif","image/png","image/x-png","image/bmp");
@ext = ("jpg","jpg","gif","png","png","bmp");

my $name = $query->param('up');

my $mime = $query->uploadInfo($name)->{'Content-Type'};
#--awa-->
my $mimetype1 = $query->uploadInfo($name)->{'Content-Transfer-Encoding'};
#--awa--<

my $cxp = "1";
my $cou = @data;

for ($a=0; $a<$cou; $a++)  {
if($mime eq $data[$a]){
$new = "$no.$ext[$a]";
$cxp = "0";
last;}
}

$new = "/$new";

#--awa-->
if ($mimetype1 eq 'base64'){$cxp = "0"; $new = "/$no.jpg";}
#--awa--<

if($cxp eq "1"){&error("アップロードできないファイルです");}

my $size = (stat($name))[7];
if($max * 1024 < $size){&error("ファイルが大きすぎます");}

$up_file = "$file$new";

open (OUT, ">$up_file");
binmode (OUT);

#--awa-->
if ($mimetype1 eq 'base64'){
	my $line;
while(read($name, $buffer,1024)){
		$line .= $buffer;
	}
	print OUT decode_base64($line);	
}else
{ 
	while(read($name, $buffer ,1024)){
		print OUT $buffer;
	}
}
#while(read($name, $buffer, 1024)){
#print OUT $buffer;}
#--awa--<



close (OUT);
close ($name);
chmod (0604, "$up_file");

($format, $width, $height) = &GetImageSize($up_file);

if($wid_max < $width or $hei_max < $height){&resize($width,$height);}
}


sub GetImageSize{
    my ( $IMG, $in ) = @_;
    my ( %SHT, %LNG );
    my ( $buf, $mark, $type, $f_size, $width, $height );
    my ( $TAG, $TYPE, $COUNT, $V_OFFSET, $PK, $ENTRY, $Exif_IFD );
    my ( $endian, $dummy1, $dummy2, $dummy, $EOI, $APP1, $length, $exif );
    my ( $format, $offset, $line, $CODE, $jfif, $i );
    my @TGA;
    my $ntag;

    # 定数
    $mark = pack("C", 0xff);
    %SHT = ( 'II' => 'v', 'MM' => 'n' );
    %LNG = ( 'II' => 'V', 'MM' => 'N' );

    # 初期値
    $endian   = '';
    $width    = -1;
    $height   = -1;
    $format   = '';
    $Exif_IFD = -1;

    if( $in eq '' ){
	$in = 'IMG';
    }

    open( $in, $IMG ) || return( '', -1, -1 );

    binmode($in);
    seek( $in, 0, 0 );
    read( $in, $buf, 6 );

    # GIF 形式
    if($buf =~ /^GIF/i){
	$format = 'GIF';
	read( $in, $buf, 2 );
	$width  = unpack("v*", $buf);
	read( $in, $buf, 2);
	$height = unpack("v*", $buf);

    # Windows Bit Map 形式
    }elsif($buf =~ /BM/){
	$format = 'BMP';
	seek( $in, 12, 1 );
	read( $in, $buf, 8 );
	($width, $height) = unpack("VV", $buf);

    # TIFF 形式
    }elsif( $buf =~ /(II)/ || $buf =~ /(MM)/ ){
	$format = 'TIFF';
	$endian = $1;
	seek( $in, 0, 0 );
	read( $in, $buf, 8 );
	( $endian, $dummy1, $offset ) = 
	    unpack( "A2$SHT{$endian}$LNG{$endian}", $buf );

	seek( $in, $offset, 0 );
	read( $in, $buf, 2 );
	$ENTRY = unpack( $SHT{$endian}, $buf );

	for( $i = 0 ; $i < $ENTRY ; $i++ ){
	    read( $in, $buf, 8 );
	    $PK = "$SHT{$endian}$SHT{$endian}$LNG{$endian}";
	    ( $TAG, $TYPE, $COUNT ) = unpack( $PK, $buf );

	    read( $in, $buf, 4 );
	    ( $TAG != 256 && $TAG != 257 ) and next;
	    if( $TYPE == 3 ){
		$PK = "$SHT{$endian}";
	    }elsif( $TYPE == 4 ){
		$PK = "$LNG{$endian}";
	    }else{
		next;
	    }

	    $V_OFFSET = unpack( $PK, $buf );

	    # Image width and height
	    ( $TAG == 256   ) and ( $width  = $V_OFFSET   );
	    ( $TAG == 257   ) and ( $height = $V_OFFSET   );
	    ( $TAG == 34665 ) and ( $format .= '-EXIF'    );
	}

    # PPM 形式
    }elsif( $buf =~ /^(P[123456])\n/ ){
	if( $1 eq 'P1' || $1 eq 'P4' ){
	    $format = 'PBM';
	}elsif( $1 eq 'P2' || $1 eq 'P5' ){
	    $format = 'PGM';
	}else{
	    $format = 'PPM';
	}
	seek( $in, 0, 0 );
	<$in>;
	while( <$in> ){
	    next if ( /^\#/ );
	    chomp;
	    ( $width, $height ) = split( /\s+/, $_ );
	    last;
	}

    # PNG 形式
    }elsif( $buf =~ /PNG/){
	$format = 'PNG';
	seek( $in, 8, 0 );

	while(1){
	    read( $in, $buf, 8 );
	    ( $offset, $CODE ) = unpack( "NA4", $buf );

	    if( $CODE eq 'IHDR' ){
		read( $in, $buf, 8 );
		( $width, $height ) = unpack( "NN", $buf );
		seek( $in, $offset-8+4, 1 );
		last;

	    }elsif( $CODE eq 'IEND' ){
		last;

	    }else{
		seek( $in, $offset+4, 1 );
	    }
	}

    }else{
	# JPEG 形式
	seek( $in, 0, 0 );
	read( $in, $buf, 2 );
	( $buf, $type ) = unpack("C*", $buf );
	if( $buf == 0xFF && $type == 0xD8 ){
	    $format = 'JPEG';
	  JPEG:while(read( $in, $buf, 1 )){
	      if(($buf eq $mark) && read( $in, $buf, 3 )){
		  $type   = unpack("C*", substr($buf, 0, 1));
		  $f_size = unpack("n*", substr($buf, 1, 2));

		  ( $type == 0xD9 ) and ( last JPEG );
		  ( $type == 0xDA ) and ( last JPEG );

		  if($type == 0xC0 || $type == 0xC2){
		      read( $in, $buf, $f_size-2 );
		      $height = unpack("n*", substr($buf, 1, 2));
		      $width  = unpack("n*", substr($buf, 3, 2));
		      ( $format =~ /EXIF/ ) and ( last JPEG );

		  }elsif( $type == 0xE1 ){
		      read( $in, $buf, $f_size-2 );
		      $exif = unpack( "A4", substr( $buf, 0, 4 ) );
		      if( $exif =~ /exif/i ){
			  $format .= '-EXIF';
			  ( $width > 0 && $height > 0 ) and ( last JPEG );
		      }

		  }elsif( $type == 0xE0 ){
		      read( $in, $buf, $f_size-2 );
		      $jfif = unpack( "A4", substr( $buf, 0, 4 ) );
		      if( $jfif =~ /jfif/i ){
			  $format .= '-JFIF';
		      }

		  }elsif( $type == 0x01 || $type == 0xFF ||
			  ( $type >= 0xD0 && $type < 0xD9 ) ){
		      seek( $in, -2, 1 );

		  }else{
		      read( $in, $buf, $f_size-2 );
		  }
	      }
	  }
	}

	if( $width > 0 && $height > 0 ){
	    close( $in );
	    return( $format, $width, $height );
	}

	# TGA 形式
	seek( $in, 0, 0 );
	read( $in, $buf, 18 );
	@TGA = unpack( "CCCvvCvvvvCC", $buf );
	if( $TGA[1] == 0 || $TGA[1] == 1 ){
	    if( $TGA[2] ==  0 || $TGA[2] == 1 || $TGA[2] ==  2 ||
		$TGA[2] ==  3 || $TGA[2] == 9 || $TGA[2] == 10 ||
		$TGA[1] == 11 ){
		$format = 'TGA';
		$width  = $TGA[8];
		$height = $TGA[9];
	    }
	}

    }

    close( $in );
    return( $format, $width, $height );
}


sub resize{
($width,$height) = @_;

if($hei_max < $height && $wid_max >= $width){$mode = 0;}
elsif($wid_max < $width && $hei_max >= $height){$mode = 1;}
else{$mode = 2;}

if($mode eq "0"){
$s1 = $height;
$s2 = $width;
$s3 = $hei_max;}

else{
$s1 = $width;
$s2 = $height;
$s3 = $wid_max;}

$re = $s3 / $s1;
$re = sprintf("%.4f",$re);
$new_size = int($s2 * $re);

if($mode eq "2" && $hei_max < $new_size){
$re = $hei_max / $new_size;
$re = sprintf("%.4f",$re);

$s3 = int($s3 * $re);
$new_size = $hei_max;}

if($mode eq "0"){
$width = $new_size;
$height = $s3;}

else{
$width = $s3;
$height = $new_size;}

return ($width,$height);
}


sub error {
my $mes = $_[0];
print "Content-type: text/html; charset=utf-8\n\n"; 
print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
print "<html lang=\"ja\">\n";
print "<head>\n";
print "<meta http-equiv=\"Content-type\" content=\"text/html; charset=utf-8\">\n";
print "<title>エラー</title>\n";
print "<meta http-equiv=\"content-style-type\" content=\"text/css\">\n";
print "<link rel=\"stylesheet\" href=\"style.css\" type=\"text/css\">\n";
print "</head>\n";
print "<body>\n";
print "<div class=\"e_title\">エラー</div>\n";
print "<div class=\"e_main\">$mes</div>\n";
print "<div class=\"e_back\">[<a href=\"$back\">戻る</a>]</div>\n";
print "<div class=\"e_footer\">- <a href=\"http://www.candy-cgi.com/\" target=\"_blank\">CANDY CGI</a> -</div>\n";
print "</body>\n";
print "</html>\n";
exit;
}


sub end {
my $mes = $_[0];
print "Content-type: text/html; charset=utf-8\n\n"; 
print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
print "<html lang=\"ja\">\n";
print "<head>\n";
print "<meta http-equiv=\"Content-type\" content=\"text/html; charset=utf-8\">\n";
print "<title>投稿、更新完了</title>\n";
print "<meta http-equiv=\"content-style-type\" content=\"text/css\">\n";
print "<link rel=\"stylesheet\" href=\"style.css\" type=\"text/css\">\n";
print "</head>\n";
print "<body>\n";
print "<div class=\"e_title\">投稿、更新完了</div>\n";
print "<div class=\"e_main\">$mes</div>\n";
print "<div class=\"e_back\">[<a href=\"$back\">戻る</a>]</div>\n";
print "<div class=\"e_footer\">- <a href=\"http://www.candy-cgi.com/\" target=\"_blank\">CANDY CGI</a> -</div>\n";
print "</body>\n";
print "</html>\n";
exit;
}


sub html {
local ($a,$b,$c,$d) = @_;

if($a eq "1"){open (OUT,">index.html");}
else{open (OUT,">$a.html");}

#=====================================================================
#　ページのデザイン【ここから】
#=====================================================================
print OUT "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
print OUT "<html lang=\"ja\">\n";
print OUT "<head>\n";
print OUT "<meta http-equiv=\"Content-type\" content=\"text/html; charset=utf-8\">\n";
#--awa-->
print OUT "<meta http-equiv=\"Pragma\" CONTENT=\"no-cache\">\n";
#--awa--<
print OUT "<title>$site_title</title>\n";
print OUT "<meta http-equiv=\"content-style-type\" content=\"text/css\">\n";
print OUT "<link rel=\"stylesheet\" href=\"style.css\" type=\"text/css\">\n";
print OUT "</head>\n";
print OUT "<body name=\"top\">\n";
print OUT "<div class=\"title\">$site_title</div>\n";


if($a eq "1"){print OUT "<div class=\"header1_top\">$header_comment_top</div>\n";}
else{print OUT "<div class=\"header1\">$header_comment</div>\n";}

	if($a eq "1" && $toukou eq "1"){
	print OUT "<div class=\"input1\">\n";
	&inp_form;}

print OUT "<div class=\"header2\">\n";
if($a ne "1"){print OUT "Page : \n";}

	for ($i=1; $i<=$d; $i++) {
	if($i eq $a){
	if($i eq "1" && $home ne ""){print OUT "[<a href=\"$home\">HOME</a>]\n";}
	print OUT " $i\n";
	}
	else{&pri_page;}
	}


print OUT "</div><div class=\"back1\"><a href=\"#bottom\">下に移動▼</a></div><div class=\"xxx\">\n";

if($toukou eq "1"){for ($i=$b; $i<=$c - 1; $i++) {&pri_main;}}
if($toukou eq "2"){for ($i=$c - 1; $i>=$b; $i--) {&pri_main;}}

print OUT "</div><div class=\"back2\"><a href=\"#top\">上に移動▲</a></div>\n";


print OUT "<div class=\"footer1\">\n";
print OUT "Page : ";

	for ($i=1; $i<=$d; $i++) {
	if($i eq $a){print OUT "$i\n"}
	else{&pri_page;}
	}

print OUT "</div>\n";

	if($a eq "1" && $toukou eq "2"){
	print OUT "<div class=\"input2\">\n";
	&inp_form;}

if($a eq "1"){print OUT "<div class=\"footer2_top\">$footer_comment_top</div>";}
else{print OUT "<div class=\"footer2\">$footer_comment</div>";}


print OUT "<div class=\"footer3\"><a name=\"bottom\">-</a> <a href=\"http://www.candy-cgi.com/\" target=\"_blank\">CANDY CGI</a> -</div>\n";
print OUT "</body></html>\n";

#=====================================================================
#　ページのデザイン【ここまで】
#=====================================================================

close (OUT);}


#=====================================================================
#　デザインのパーツ【ここから】
#=====================================================================
sub pri_main {
($noy1,$timey1,$ipy1,$hosty1,$namey1,$titley1,$nitiy1,$messagey1,$up_filey1,$widthy1,$heighty1) = split(/<>/, $log[$i]);

if ($log[$i] eq "") {
$noy1 = "0";
$timey1 = "No Title";
$namey1 = "名無しさん";
$titley1 = "投稿はまだありません";
$nitiy1 = "00/00/00(X) 00:00:00";
$messagey1 = "投稿フォームから書き込みできます。";
}

chomp($heighty1);

$noy1 = sprintf("%04d",$noy1);

print OUT "<div class=\"post\"><span class=\"in_no\">$noy1</span> : <span class=\"in_title\">$titley1</span>　<span class=\"in_name1\">名前：</span><span class=\"in_name2\">$namey1</span>　<span class=\"in_nitizi1\">投稿：</span><span class=\"in_nitizi2\">$nitiy1</span></div>\n";

if ($up_filey1 ne "") {
print OUT "<div class=\"left\"><a href=\"$up_filey1\"><img width=\"$widthy1\" height=\"$heighty1\" src=\"$up_filey1\" alt=\"\"></a></div>\n";
print OUT "<div class=\"right\">$messagey1</div><br class=\"clear\" />\n";
}

else{print OUT "<div class=\"mess\">$messagey1</div>\n";}
}

sub inp_form {
#--awa-->
#print OUT "<form method=\"post\" action=\"index.cgi\" enctype=\"multipart/form-data\">\n";
#print OUT "タイトル : <input type=\"text\" name=\"ghjfk\" size=\"23\">　　名前 : <input type=\"text\" name=\"jdvos\" size=\"22\">　<input type=\"submit\" name=\"entry\" value=\"書き込む\"><br>\n";
#print OUT "<textarea name=\"kvkfp\" cols=\"60\" rows=\"5\" wrap=\"off\"></textarea><br>\n";
#print OUT "ファイル : <input type=\"file\" name=\"up\" size=\"64\"><br>\n";

#print OUT "</form>\n";

print OUT "<object classid=\"clsid:233C1507-6A77-46A4-9443-F871F945D258\" \n";
print OUT " codebase=\"http://download.macromedia.com/pub/shockwave/cabs/director/sw.cab#version=11,0,0,0\"\n";
print OUT " ID=postTest width=320 height=190 VIEWASTEXT> \n";
print OUT "<param name=src value=\"postTest.dcr\"> \n";
print OUT "<param name=swRemote value=\"swSaveEnabled='true' swVolume='true' swRestart='true' swPausePlay='true' swFastForward='true' swContextMenu='true' \"> \n";
print OUT "<param name=swStretchStyle value=none>\n";
print OUT "<param name=PlayerVersion value=11>\n";
print OUT "<PARAM NAME=bgColor VALUE=#BACDCD> \n";
print OUT "<embed src=\"postTest.dcr\" bgColor=#BACDCD  width=320 height=190 swRemote=\"swSaveEnabled='true' swVolume='true' swRestart='true' swPausePlay='true' swFastForward='true' swContextMenu='true' \" swStretchStyle=none\n";
print OUT " type=\"application/x-director\" PlayerVersion=11 pluginspage=\"http://www.macromedia.com/shockwave/download/\"></embed>\n";
print OUT "</object>\n";

print OUT "</div>\n";
#--awa--<
}

sub pri_page {
if($i eq "1"){print OUT "<a href=\"./\">$i</a>\n";}
else{print OUT " <a href=\"$i.html\">$i</a>\n";}
}

#=====================================================================
#　デザインのパーツ【ここまで】
#=====================================================================
